package com.clx.performance.controller.temp;

import com.clx.performance.service.linewarn.LineWarnMqService;
import com.msl.common.result.Result;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * @Author: aiqingguo
 * @Description: 临时接口
 * @Date: 2023-8-21 12:10:16
 * @Version: 1.0
 */
@Slf4j
@RestController
@RequestMapping(value="/temp/lineWarn")
public class TempLineWarnController {

    @Autowired
    private LineWarnMqService lineWarnMqService;

    @ApiOperation(value = "线路上报", notes = "<br>By:艾庆国")
    @PostMapping("/lineReport")
    public Result lineReport(Integer sendSystemAddressId, Integer receiveSystemAddressId,
                          Integer reportType, Integer estimatedTravelTime) {

        lineWarnMqService.lineReport(sendSystemAddressId, receiveSystemAddressId, reportType, estimatedTravelTime);

        return Result.ok();
    }


}
